def can_form_correct_cube(numbers):
    total_sum = sum(numbers)
    
    # Если сумма не делится на 3, невозможно создать правильный кубик
    if total_sum % 3 != 0:
        return False
    
    target_sum = total_sum // 3
    # Проверка всех возможных пар противоположных граней
    valid_pairs = [
        (numbers[0], numbers[5]),
        (numbers[1], numbers[4]),
        (numbers[2], numbers[3])
    ]
    
    # Проверяем, могут ли пары дать одинаковую сумму
    for pair in valid_pairs:
        if pair[0] + pair[1] != target_sum:
            return False
    
    return True

# Чтение данных
n = int(input())
results = []

for _ in range(n):
    numbers = list(map(int, input().split()))
    if can_form_correct_cube(numbers):
        results.append("yes")
    else:
        results.append("no")

# Вывод результатов
print("\n".join(results))
