def can_form_cube(rolls):
    # Проверяем, можно ли сформировать правильный кубик
    # Кубик правильный, если числа могут быть разделены на 3 пары
    # где каждое число из пары одно из противоположных граней
    if len(rolls) != 6:
        return False

    # Считаем количество каждой цифры
    counts = {}
    for number in rolls:
        if number in counts:
            counts[number] += 1
        else:
            counts[number] = 1
        
    # Проверяем, что каждое число встречается четное количество раз
    return all(count % 2 == 0 for count in counts.values())

def main():
    n = int(input().strip())
    
    results = []
    for _ in range(n):
        # Читаем очередной набор чисел
        rolls = list(map(int, input().strip().split()))
        
        if can_form_cube(rolls):
            results.append("yes")
        else:
            results.append("no")

    # Выводим результаты
    print("\n".join(results))

if __name__ == "__main__":
    main()
