def lunar_addition(a, b):
    max_length = max(len(a), len(b))
    a = a.zfill(max_length)
    b = b.zfill(max_length)
    
    lunar_sum = []
    for digit_a, digit_b in zip(a, b):
        lunar_sum.append(str(max(int(digit_a), int(digit_b))))

    return ''.join(lunar_sum)

def lunar_multiplication(a, b):
    max_length_a = len(a)
    max_length_b = len(b)
    
    # Храним промежуточные результаты
    result_grid = []
    
    # Умножаем поразрядно
    for i in range(max_length_b):
        row = []
        digit_b = int(b[max_length_b - 1 - i])  # Обратный порядок для разрядов
        carry = 0
        
        for j in range(max_length_a):
            digit_a = int(a[max_length_a - 1 - j])  # Обратный порядок для разрядов
            product = min(digit_a, digit_b)
            row.append(str(product))
            
        # Добавляем нули для соответствующего разряда
        row = row[::-1]  # Разворачиваем обратно
        row = ''.join(row) + '0' * i  # Добавляем нули
        result_grid.append(row)

    # Складываем все строки
    result = '0'
    
    for row in result_grid:
        result = lunar_addition(result, row)

    return result

# Считываем данные из стандартного ввода
import sys

input = sys.stdin.read
data = input().splitlines()

a = data[0].strip()
b = data[1].strip()

# Вычисляем сумму и произведение в лунной арифметике
lunar_sum = lunar_addition(a, b)
lunar_product = lunar_multiplication(a, b)

# Выводим результаты
print(f"{lunar_sum} {lunar_product}")
