from collections import deque, defaultdict 
import sys 
  
def fortress_guard(): 
    input = sys.stdin.read 
    data = input().split() 
      
    n, m, k = map(int, data[:3]) 
    edges = data[3:3 + 2 * m] 
    guards = data[3 + 2 * m:] 
      
    graph = defaultdict(list) 
    for i in range(m): 
        a, b = map(int, edges[2 * i:2 * i + 2]) 
        graph[a].append(b) 
        graph[b].append(a) 
  
    guard_positions = [] 
    for i in range(k): 
        p, h = map(int, guards[2 * i:2 * i + 2]) 
        guard_positions.append((p, h)) 
  
    max_distance = [-1] * (n + 1) 
    queue = deque() 
  
    for p, h in guard_positions: 
        max_distance[p] = h 
        queue.append((p, h)) 
  
    while queue: 
        current, distance = queue.popleft() 
        if distance == 0: 
            continue 
        for neighbor in graph[current]: 
            if max_distance[neighbor] < distance - 1: 
                max_distance[neighbor] = distance - 1 
                queue.append((neighbor, distance - 1)) 
  
    guarded_warehouses = [i for i in range(1, n + 1) if max_distance[i] >= 0] 
    print(len(guarded_warehouses)) 
    print(" ".join(map(str, sorted(guarded_warehouses)))) 
  
if name == "__main__": 
    fortress_guard()
