from collections import deque, defaultdict

def main():
    # Считываем n (склады), m (дороги), k (охранники)
    n, m, k = map(int, input().split())
    
    # Создаем граф в виде списка смежности
    graph = defaultdict(list)
    
    # Считываем дороги
    for _ in range(m):
        a, b = map(int, input().split())
        graph[a].append(b)
        graph[b].append(a)
    
    # Считываем охранников
    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))
    
    protected = set()  # Для хранения охраняемых складов

    # Обрабатываем каждого охранника
    for start, endurance in guards:
        # BFS
        queue = deque([(start, 0)])  # (номер склада, текущая длина пути)
        visited = set()  # Охваченные склады для текущего охранника
        
        while queue:
            node, distance = queue.popleft()
            
            if node in visited:
                continue
            
            visited.add(node)
            protected.add(node)  # Добавляем текущий склад в охраняемые
            
            # Если расстояние достигает предела выносливости, выходим
            if distance < endurance:
                for neighbor in graph[node]:
                    if neighbor not in visited:
                        queue.append((neighbor, distance + 1))
    
    # Результаты
    protected = sorted(protected)  # Сортируем номера охраняемых складов
    print(len(protected))
    if protected:
        print(' '.join(map(str, protected)))
    else:
        print()

if __name__ == "__main__":
    main()
