from collections import deque, defaultdict

def main():
    import sys
    input = sys.stdin.read
    data = input().splitlines()

    # Считываем n, m, k
    n, m, k = map(int, data[0].split())
    
    # Граф (хранит дороги между складами)
    graph = defaultdict(list)
    
    # Считываем дороги
    for i in range(1, m + 1):
        a, b = map(int, data[i].split())
        graph[a].append(b)
        graph[b].append(a)
    
    # Множество охраняемых складов
    protected = set()
    
    # Считываем охранников и запускаем BFS для каждого из них
    for i in range(m + 1, m + k + 1):
        p, h = map(int, data[i].split())
        # BFS
        queue = deque([(p, 0)])  # (текущий склад, текущее расстояние)
        visited = set([p])
        
        while queue:
            current, distance = queue.popleft()
            if distance > h:
                continue
            
            # Добавляем склад в охраняемые
            protected.add(current)
            
            for neighbor in graph[current]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, distance + 1))
    
    # Вывод результата
    protected = sorted(protected)
    print(len(protected))
    print(" ".join(map(str, protected)))

if __name__ == "__main__":
    main()
