import itertools
import math

def calculate_distance(point1, point2):
    return math.sqrt((point1[0] - point2[0])**2 + (point1[1] - point2[1])**2)

def total_distance(path):
    return sum(calculate_distance(path[i], path[i + 1]) for i in range(len(path) - 1))

def find_shortest_route(points):
    min_distance = float('inf')

    # Проверяем все возможные маршруты
    for perm in itertools.permutations(points):
        # Считаем длину маршрута
        current_distance = total_distance(perm)
        min_distance = min(min_distance, current_distance)
    
    return min_distance

def main():
    n = int(input().strip())
    points = [tuple(map(int, input().strip().split())) for _ in range(n)]

    shortest_route_length = find_shortest_route(points)

    # Выводим длину кратчайшего маршрута с нужной точностью
    print(f"{shortest_route_length:.6f}")

if __name__ == "__main__":
    
    main()
    print("main")
