import math
import itertools

def euclidean_distance(point1, point2):
    return math.sqrt((point1[0] - point2[0]) ** 2 + (point1[1] - point2[1]) ** 2)

def total_distance(points, order):
    dist = 0
    for i in range(len(order) - 1):
        dist += euclidean_distance(points[order[i]], points[order[i + 1]])
    return dist

def main():
    n = int(input())
    points = [tuple(map(int, input().split())) for _ in range(n)]

    min_distance = float('inf')

    # Генерируем все возможные перестановки точек и вычисляем расстояние для каждого маршрута
    for order in itertools.permutations(range(n)):
        current_distance = total_distance(points, order)
        min_distance = min(min_distance, current_distance)

    # Выводим минимальную дистанцию с точностью до 6 знаков после запятой
    print(f"{min_distance:.9f}")

if __name__ == "__main__":
    main()
