import itertools
import math

def manhattan_distance(point1, point2):
    return abs(point1[0] - point2[0]) + abs(point1[1] - point2[1])

def total_path_distance(path, points):
    total_distance = 0
    for i in range(len(path) - 1):
        total_distance += manhattan_distance(points[path[i]], points[path[i + 1]])
    return total_distance

def main():
    n = int(input())
    points = [tuple(map(int, input().split())) for _ in range(n)]
    
    # Извлекаем все возможные перестановки адресов
    min_distance = float('inf')
    
    for perm in itertools.permutations(range(n)):
        # Рассчитываем расстояние для текущей перестановки
        current_distance = total_path_distance(perm, points)
        min_distance = min(min_distance, current_distance)
    
    # Для точности, выводим с 9 знаками после запятой
    print(f"{min_distance:.9f}")

if __name__ == "__main__":
    main()
